#!/usr/bin/env bash

TYPE_SPEED="${TYPE_SPEED:-15}"
PROMPT_TIMEOUT="${PROMPT_TIMEOUT:--1}"

function simtyping()
{ pv -qL $(($TYPE_SPEED+$((-2 + RANDOM%5)))); }

function wait()
{
    if [ "$PROMPT_TIMEOUT" == "-1" ]; then
        read -rs
    else
        read -rst "$PROMPT_TIMEOUT"
    fi
    printf "\n"
}

function type()
{ printf "$*" | simtyping; }

function execute()
{
    printf "$(whoami)@$(hostname)\$ "
    type "$@" && wait
    eval "$@"
}

function cmd()
{ read command && eval "${command}"; }
